#!/bin/sh

DIAGNOSTICS="/var/log/diagnostics"

rm -rf $DIAGNOSTICS
mkdir $DIAGNOSTICS

env > $DIAGNOSTICS/environment.txt

uci show > $DIAGNOSTICS/uci_config.txt

tar czf $DIAGNOSTICS/conf.tar.gz -C /mnt/data conf

uptime > $DIAGNOSTICS/uptime.txt

top -b -n 5 > $DIAGNOSTICS/top_samples.txt

cp /proc/meminfo $DIAGNOSTICS/meminfo.txt

tar czf $DIAGNOSTICS/netstats.tar.gz -C /proc/net .

ping -c 10 player.manage.barix.com > $DIAGNOSTICS/ping_portal.txt

traceroute player.manage.barix.com > $DIAGNOSTICS/traceroute_portal.txt

cp /etc/resolv.conf $DIAGNOSTICS/resolv.conf

cp /etc/network/interfaces $DIAGNOSTICS/network_interfaces.txt

df -h > $DIAGNOSTICS/filesystem_usage.txt

nslookup 1.barix.pool.ntp.org > $DIAGNOSTICS/lookup_ntp.txt

nslookup barixupdate.com > $DIAGNOSTICS/lookup_downloads.txt

echo "NO_INFO" > $DIAGNOSTICS/factory_info
echo "NO_INFO" > $DIAGNOSTICS/factory_info.json

cp /tmp/factory_info_partition/factory_info $DIAGNOSTICS/factory_info
cp /tmp/factory_info_partition/factory_info_json $DIAGNOSTICS/factory_info.json

tar cp -R /mnt/data/conf/ $DIAGNOSTICS/conf


tar vczf /lastlogs.tar.gz -C /var/log .
